//To do:
//
//Add a save boot state dialog, which would have a "reset everything to
//  factory defaults" button.
//Add fan fail-safe to fans dialog
//Add "ATX" control setup & host reset watchdog dialog
//Add custom characters dialog ?
//Make window positions and state persistent ? (disagrees with 631_WinTest
//  "no install" convention where only the exe exists. Hmmmm, maybe write
//  back into the exe. That should make the virus scanners happy. :)
//
//============================================================================
// 631_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
//Version 1.9: It is not as ugly as before. But it is still pretty ugly.
//============================================================================
// 631_WinTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "631_WinTest.h"
#include "Live_Display.h"
#include "serial.h"
#include "GPIO.h"
#include "KeyPads.h"
#include "TempsDlg.h"
#include "Fans.h"
#include "Packet_Debug.h"
#include "LED_Editor.h"
#include "631_WinTestDlg.h"
#include "EnumSerial.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//==============================================================================
// List of serial ports.
CArray<SSerInfo,SSerInfo&> asi;
//==============================================================================
void CMy631_WinTestDlg::Find_Serial_Ports(void)
  {
  // Populate the list of serial ports.
  m_port.ResetContent();
  //CArray<SSerInfo,SSerInfo&> asi;
  //This code modified from 
  //http://www.codeproject.com/system/setupdi.asp

  EnumSerialPorts(asi,FALSE/*include all*/);
  if(asi.GetSize())
    {
    for(int ii=0; ii<asi.GetSize(); ii++)
      m_port.AddString(asi[ii].strFriendlyName);
    }
  else
    {
    m_port.AddString("Whups . . . no COM ports!");
    m_port.SetCurSel(0);
    m_port.EnableWindow(0);
    }
  }
//==============================================================================
void CMy631_WinTestDlg::set_serial(int port)
  {
  int
    baud;
  if(m_baud_19200.GetCheck())
    baud=19200;
  else
    baud=115200;


  if(!Serial_Init((LPSTR)(const char *)asi[m_port.GetCurSel()].strDevPath,baud,this))
    {
    update_state=UPDATE_STATE_VERSION;
    }
  else
    {
    m_comm_status.SetWindowText("Can't open port.");
    m_port.SetCurSel(-1);
    }
  }
//------------------------------------------------------------------------------

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
  CAboutDlg();

// Dialog Data
  //{{AFX_DATA(CAboutDlg)
  enum { IDD = IDD_ABOUTBOX };
  //}}AFX_DATA

  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CAboutDlg)
  protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  //}}AFX_VIRTUAL

// Implementation
protected:
  //{{AFX_MSG(CAboutDlg)
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
  //{{AFX_DATA_INIT(CAboutDlg)
  //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CAboutDlg)
  //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
  //{{AFX_MSG_MAP(CAboutDlg)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy631_WinTestDlg dialog

CMy631_WinTestDlg::CMy631_WinTestDlg(CWnd* pParent /*=NULL*/)
  : CDialog(CMy631_WinTestDlg::IDD, pParent)
  {
  //{{AFX_DATA_INIT(CMy631_WinTestDlg)
  //}}AFX_DATA_INIT
  // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
  m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  //Remember that the packet debugger does not exist yet.
  m_pPacket_Debug = NULL;
  m_pLive_Display = NULL;
  m_pGPIO = NULL;
  m_pKeyPads = NULL;
  m_pTempsDlg = NULL;
  m_pFansDlg = NULL;
  }

void CMy631_WinTestDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CMy631_WinTestDlg)
	DDX_Control(pDX, IDC_AUTO_UPDATE, m_auto_update);
  DDX_Control(pDX, IDC_PORT_COMBO, m_port);
  DDX_Control(pDX, IDC_BAUD_19200, m_baud_19200);
  DDX_Control(pDX, IDC_BAUD_115200, m_baud_115200);
  DDX_Control(pDX, IDC_COMM_STATUS, m_comm_status);
  DDX_Control(pDX, IDC_ENABLE_LOG_FANS, m_enable_log_fans);
  DDX_Control(pDX, IDC_BACKLGHT_SLIDER, m_backlight);
  DDX_Control(pDX, IDC_CONTRAST_SLIDER, m_contrast);
  DDX_Control(pDX, IDC_CONTRAST_PERCENT, m_contrast_percent);
  DDX_Control(pDX, IDC_BACKLIGHT_PERCENT, m_backlight_percent);
  DDX_Control(pDX, IDC_LCD_LINE_2, m_LCD_Line_2);
  DDX_Control(pDX, IDC_LCD_LINE_1, m_LCD_Line_1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy631_WinTestDlg, CDialog)
  //{{AFX_MSG_MAP(CMy631_WinTestDlg)
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_BAUD_115200, OnBaud115200)
  ON_BN_CLICKED(IDC_BAUD_19200, OnBaud19200)
  ON_CBN_CLOSEUP(IDC_PORT_COMBO, OnCloseupPortCombo)
  ON_CBN_DROPDOWN(IDC_PORT_COMBO, OnDropdownPortCombo)
  ON_BN_CLICKED(IDC_ENABLE_LOG_FANS, OnEnableLogFans)
  ON_BN_CLICKED(IDC_GPIO, OnGPIO)
  ON_WM_HSCROLL()
  ON_BN_CLICKED(IDC_FANS, OnFans)
  ON_BN_CLICKED(IDC_KEYPADS, OnKeyPads)
  ON_BN_CLICKED(IDC_LIVE_DISPLAY, OnLiveDisplay)
  ON_BN_CLICKED(ID_PACKET_DEBUGGER, OnPacketDebugger)
  ON_WM_PAINT()
  ON_BN_CLICKED(IDC_SEND_LCD_LINE_1, OnSendLcdLine1)
  ON_BN_CLICKED(IDC_SEND_LCD_LINE_2, OnSendLcdLine2)
  ON_WM_SYSCOMMAND()
  ON_BN_CLICKED(IDC_TEMPERATURES, OnTemperatures)
  ON_BN_CLICKED(ID_DONE, OnExit)
	ON_BN_CLICKED(IDC_LED, OnLed)
	ON_BN_CLICKED(ID_CHARACTER_SET, OnCharacterSet)
  ON_WM_TIMER()
	ON_EN_CHANGE(IDC_LCD_LINE_1, OnChangeLcdLine1)
	ON_EN_CHANGE(IDC_LCD_LINE_2, OnChangeLcdLine2)
	ON_BN_CLICKED(IDC_AUTO_UPDATE, OnAutoUpdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
//was 25

#define POLL_INTERVAL 10  //nominally 1/100 sec
#define ID_TIMER1     1
/////////////////////////////////////////////////////////////////////////////
typedef struct
  {
  int
    fans_have_data[8];
  int
    fans[8];
  int
    temps_have_data[32];
  double
    temps[32];
  } LOG_LINE_STRUCT;

LOG_LINE_STRUCT
  log_line;

FILE
  *fan_log;

int
  log_count;
/////////////////////////////////////////////////////////////////////////////
#define DEFAULT_CONTRAST 128
/////////////////////////////////////////////////////////////////////////////
// CMy631_WinTestDlg message handlers

BOOL CMy631_WinTestDlg::OnInitDialog()
  {
  CDialog::OnInitDialog();

  // Add "About..." menu item to system menu.

  // IDM_ABOUTBOX must be in the system command range.
  ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
  ASSERT(IDM_ABOUTBOX < 0xF000);

  CMenu* pSysMenu = GetSystemMenu(FALSE);
  if (pSysMenu != NULL)
    {
    CString strAboutMenu;
    strAboutMenu.LoadString(IDS_ABOUTBOX);
    if (!strAboutMenu.IsEmpty())
      {
      pSysMenu->AppendMenu(MF_SEPARATOR);
      pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
      }
    }

  // Set the icon for this dialog.  The framework does this automatically
  //  when the application's main window is not a dialog
  SetIcon(m_hIcon, TRUE);     // Set big icon
  //SetIcon(m_hIcon, FALSE);    // Set small icon
  
  // TODO: Add extra initialization here
  int
    i;
  fan_log=NULL;

  for(i=0;i<=7;i++)
    log_line.fans_have_data[i]=0;
  for(i=0;i<=31;i++)
    log_line.temps_have_data[i]=0;
  
  //Set the font of the LCD lines to fixed-pitch
  HFONT m_hFont;
  CFont *m_pFont;
  m_hFont = (HFONT)GetStockObject(ANSI_FIXED_FONT);
  m_pFont = CFont::FromHandle (m_hFont);
  m_LCD_Line_1.SetFont (m_pFont);
  m_LCD_Line_2.SetFont (m_pFont);

  m_LCD_Line_1.SetWindowText("* Crystalfontz 631 *");
  m_LCD_Line_2.SetWindowText("*** 631 WinTest  ***");

  //Create the (hidden) Packet_Debug dialog. This needs to happen early,
  //since other Create() calls will send packets.
  m_pPacket_Debug = new Packet_Debug(this);
  ASSERT(m_pPacket_Debug != NULL);
  m_pPacket_Debug->Create();

  //Create the (hidden) fans dialog 
  m_pFansDlg = new FansDlg(this);
  ASSERT(m_pFansDlg != NULL);
  m_pFansDlg->Create();

  //Create the (hidden) temps dialog 
  m_pTempsDlg = new TempsDlg(this);
  ASSERT(m_pTempsDlg != NULL);
  m_pTempsDlg->Create();

  //Create the (hidden) KeyPads dialog 
  m_pKeyPads = new KeyPads(this);
  ASSERT(m_pKeyPads != NULL);
  m_pKeyPads->Create();

  //Create the (hidden) Live_Display dialog 
  m_pLive_Display = new Live_Display(this);
  ASSERT(m_pLive_Display != NULL);
  m_pLive_Display->Create();

  //Create the (hidden) GPIO dialog 
  m_pGPIO = new GPIO(this);
  ASSERT(m_pGPIO != NULL);
  m_pGPIO->Create();

  //Create the (hidden) GPIO dialog 
  m_pLED_Editor = new LED_Editor(this);
  ASSERT(m_pLED_Editor != NULL);
  m_pLED_Editor->Create();

  char
    string[10];

  m_contrast.SetRange(0, 255);
  m_contrast.SetPos(last_contrast=DEFAULT_CONTRAST);
  sprintf(string,"%d%%",((last_contrast*100)/255));
  m_contrast_percent.SetWindowText(string);

  m_backlight.SetRange(0, 100);
  m_backlight.SetPos(last_backlight=100);
  sprintf(string,"%d%%",last_backlight);
  m_backlight_percent.SetWindowText(string);

  //Initialize the live array
  int
    slot;
  for(slot=0;slot<=7;slot++)
    {
    live[slot].type=0;   //off
    live[slot].index=0;
    live[slot].digits=5; //valid for fan or temp
    live[slot].column=0;
    live[slot].row=0;
    live[slot].units=1;  // 1 PPR or deg F
    }

  m_baud_19200.SetCheck(0);
  m_baud_115200.SetCheck(1);

  // Populate the list of serial ports.
  Find_Serial_Ports();

  //The 631 is USB always, and its "friendly name" will have CFA631 in it. See if
  //one of the strings contains "CFA631" and is not already in use.
  m_port.SetCurSel(-1);
  for(int ii=0; ii<asi.GetSize(); ii++)
    {
    if(strstr(asi[ii].strFriendlyName,"CFA631")&&
       (!(asi[ii].bPortAlreadyOpen)))
      m_port.SetCurSel(ii);
    }

  //Failing that, just open the first unused port
  if(-1==m_port.GetCurSel())
    {
    for(ii=0; ii<asi.GetSize(); ii++)
      {
      if(!(asi[ii].bPortAlreadyOpen))
        {
        m_port.SetCurSel(ii);
        break;
        }
      }
    }

  //Go ahead and open whatever looked good
  if(-1!=m_port.GetCurSel())
    set_serial(m_port.GetCurSel());
 
  StartTimer(POLL_INTERVAL);

  return TRUE;  // return TRUE  unless you set the focus to a control
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnExit() 
  {
  StopTimer();
  Uninit_Serial();
  if(fan_log)
    fclose(fan_log);
  CDialog::OnOK();  
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
  if ((nID & 0xFFF0) == IDM_ABOUTBOX)
  {
    CAboutDlg dlgAbout;
    dlgAbout.DoModal();
  }
  else
  {
    CDialog::OnSysCommand(nID, lParam);
  }
}
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnPaint() 
{
  if (IsIconic())
  {
    CPaintDC dc(this); // device context for painting

    SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

    // Center icon in client rectangle
    int cxIcon = GetSystemMetrics(SM_CXICON);
    int cyIcon = GetSystemMetrics(SM_CYICON);
    CRect rect;
    GetClientRect(&rect);
    int x = (rect.Width() - cxIcon + 1) / 2;
    int y = (rect.Height() - cyIcon + 1) / 2;

    // Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
  {
    CDialog::OnPaint();
  }
}
/////////////////////////////////////////////////////////////////////////////
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMy631_WinTestDlg::OnQueryDragIcon()
  {
  return (HCURSOR) m_hIcon;
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnPacketDebugger(void) 
  {
  //The window is created but invisible. Make it visible
  m_pPacket_Debug->ShowWindow(TRUE);
  m_pPacket_Debug->SetActiveWindow();
   //Disable the button
  GetDlgItem(ID_PACKET_DEBUGGER)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnLiveDisplay(void) 
  {
  //The window is created but invisible. Make it visible
  m_pLive_Display->ShowWindow(TRUE);
  m_pLive_Display->SetActiveWindow();
   //Disable the button
  GetDlgItem(IDC_LIVE_DISPLAY)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnGPIO(void) 
  {
  //The window is created but invisible. Make it visible
  m_pGPIO->ShowWindow(TRUE);
  m_pGPIO->SetActiveWindow();
   //Disable the button
  GetDlgItem(IDC_GPIO)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnLed() 
  {
  //The window is created but invisible. Make it visible
  m_pLED_Editor->ShowWindow(TRUE);
  m_pLED_Editor->SetActiveWindow();
   //Disable the button
  GetDlgItem(IDC_LED)->EnableWindow(FALSE);	
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnKeyPads(void) 
  {
  //The window is created but invisible. Make it visible
  m_pKeyPads->ShowWindow(TRUE);
  m_pKeyPads->SetActiveWindow();
   //Disable the button
  GetDlgItem(IDC_KEYPADS)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnTemperatures(void) 
  {
  //The window is created but invisible. Make it visible
  m_pTempsDlg->ShowWindow(TRUE);
  m_pTempsDlg->SetActiveWindow();
   //Disable the button
  GetDlgItem(IDC_TEMPERATURES)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnFans(void) 
  {
  //The window is created but invisible. Make it visible
  m_pFansDlg->ShowWindow(TRUE);
  m_pFansDlg->SetActiveWindow();
   //Disable the button
  GetDlgItem(IDC_FANS)->EnableWindow(FALSE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::LED_Editor_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pLED_Editor->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(IDC_LED)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::Packet_Debugger_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pPacket_Debug->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(ID_PACKET_DEBUGGER)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::Live_Display_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pLive_Display->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(IDC_LIVE_DISPLAY)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::GPIO_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pGPIO->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(IDC_GPIO)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::KeyPads_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pKeyPads->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(IDC_KEYPADS)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::TempsDlg_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pTempsDlg->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(IDC_TEMPERATURES)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::FansDlg_Done(void)
  {
  //The window is created and visible. Make it invisible
  m_pFansDlg->ShowWindow(FALSE);
  //Re-enable our button
  GetDlgItem(IDC_FANS)->EnableWindow(TRUE);
  }
/////////////////////////////////////////////////////////////////////////////
//This routine takes a string from the LCD module and replaces "binary"
//characters with the "\xxx" decimal escape sequence. Could make this
//look at hex/dec and ascii checks from the debugger, but it is on the
//main screen which is intended to be less "techie".
void  CMy631_WinTestDlg::Copy_And_Encode_String(char *out,const unsigned char *in,int length)
  {
  out[0]=0;
  int
    i;
  for(i=0;i<length;i++)
    {
    int
      current_length=strlen(out);
    if(isprint(in[i]))
      sprintf(&out[current_length],"%c",in[i]);
    else
      sprintf(&out[current_length],"\\%03d",in[i]);
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::flush_log_line()
  {
  //first, average the fan speeds if they are both there.
  //(fans report 2x/second, temps report 1x/sec)
  int
    this_fan;
  int
    this_fan_has_data;
  int
    i;
  char
    date_buffer[19];
  char
    time_buffer[19];
  if(fan_log)
    {
    _strdate(date_buffer);
    _strtime(time_buffer);
    fprintf(fan_log,"%s,%s,",date_buffer,time_buffer);
    }

  for(i=0;i<=3;i++)
    {
    this_fan_has_data=0;
    if(log_line.fans_have_data[i]&&log_line.fans_have_data[i+4])
      {
      this_fan=(log_line.fans[i]+log_line.fans[i+4])/2;
      this_fan_has_data=1;
      }
    else
      if(log_line.fans_have_data[i])
        {
        this_fan=log_line.fans[i];
        this_fan_has_data=1;
        }
      else
        if(log_line.fans_have_data[i+4])
          {
          this_fan=log_line.fans[i+4];
          this_fan_has_data=1;
          }
    if(fan_log)
      {
      if(this_fan_has_data)
        fprintf(fan_log,"%d,",this_fan);
      else
        fprintf(fan_log,",");
      }
    log_line.fans_have_data[i]=0;
    log_line.fans_have_data[i+4]=0;
    }
  //Now dump out the temperatures.
  for(i=0;i<=31;i++)
    {
    if(fan_log)
      {
      if(log_line.temps_have_data[i]==1)
        fprintf(fan_log,"%9.4f%s",log_line.temps[i],i==31?"\n":",");
      else
        if(log_line.temps_have_data[i]==2)
          fprintf(fan_log,"\"CRC!\"%s",i==31?"\n":",");
        else
          fprintf(fan_log,"%s",i==31?"\n":",");
      }
    log_line.temps_have_data[i]=0;
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::log_fan(int index,int rpm)
  {
  //first, see if it can fit in the first slot.
  if(!log_line.fans_have_data[index])
    {
    log_line.fans_have_data[index]=1;
    log_line.fans[index]=rpm;
    }
  else
    //try the second
    if(!log_line.fans_have_data[index+4])
      {
      log_line.fans_have_data[index+4]=1;
      log_line.fans[index+4]=rpm;
      }
    else
      {
      //time to flush the line
      flush_log_line();
      //Now put it in the first slot
      log_line.fans_have_data[index]=1;
      log_line.fans[index]=rpm;
      }
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::log_temp(int index,double temp,int data_good)
  {
  //first, see if it can fit in the first slot.
  if(!log_line.temps_have_data[index])
    {
    if(data_good)
      log_line.temps_have_data[index]=1;
    else
      log_line.temps_have_data[index]=2;
    log_line.temps[index]=temp;
    }
  else
    {
    //time to flush the line
    flush_log_line();
    //Now put it in the first slot
    if(data_good)
      log_line.temps_have_data[index]=1;
    else
      log_line.temps_have_data[index]=2;
    log_line.temps[index]=temp;
    }
  }
/////////////////////////////////////////////////////////////////////////////
//This function may have been better placed in Packet_Debug.cpp
void CMy631_WinTestDlg::OnTimer(UINT nIDEvent) 
  {
  if (nIDEvent == ID_TIMER1)
    {
    //See if any new packets have come in from the LCD module.
    if(check_for_packet())
      {
      m_pPacket_Debug->Record_Received_Packet(&incoming_response);

      unsigned char
        spinner_has_been_updated;
      spinner_has_been_updated=0;

      //Update the fields on the main window.
      switch(incoming_response.command)
        {
        case 0x80:  //Key
          m_pPacket_Debug->RollKeySpinner();
          spinner_has_been_updated=1;
          //Send the packet up to the KeyPad window
          m_pKeyPads->OnReceivedKeyReport(&incoming_response);
          break;
        case 0x81:  //Fans
          m_pPacket_Debug->RollFanSpinner();
          spinner_has_been_updated=1;
          //Send the packet to the Fans window
          m_pFansDlg->OnReceivedFanReport(&incoming_response);
          break;
        case 0x82:  //Temperature
          m_pPacket_Debug->RollTemperatureSpinner();
          spinner_has_been_updated=1;
          //Send the packet up to the Temperatures window
          m_pTempsDlg->OnReceivedTempReport(&incoming_response);
          break;
        case (0x40|18):  //Return packet from Read DOW Device information
          //Send the packet up to the Temperatures window
          m_pTempsDlg->OnReceivedSensorID(&incoming_response);
          break;
        case (0x40|1):  //Return packet from get ROM version
          if(update_state==UPDATE_STATE_VERSION_REPLY)
            {
            //Remove the "No module found." message and display the module type
            incoming_response.data[incoming_response.data_length]=0;
            char
              string[50];
            sprintf(string,"Found: %s",(char *)incoming_response.data);
            m_comm_status.SetWindowText(string);
            update_state=UPDATE_STATE_MODULE_FOUND;
            }
          break;
        case (0x40|24):  //Return packet from Read Keypad, Polled Mode
          //Send the packet up to the KeyPad window if it exists.
          if(m_pKeyPads)
            m_pKeyPads->OnReceivedKeyPoll(&incoming_response);
          break;
        case (0x40|30):  //Return packet from Read Reporting Status
          //Send the packet up to the Fan window.
          m_pFansDlg->OnReceivedReportingStatus(&incoming_response);

          //Send the packet up to the Temperature window
          m_pTempsDlg->OnReceivedReportingStatus(&incoming_response);

          //Send the packet up to the KeyPad window
          m_pKeyPads->OnReceivedReportingStatus(&incoming_response);

          char
            string[10];

          //The contrast
          m_contrast.SetPos(last_contrast=incoming_response.data[13]);
          sprintf(string,"%d%%",((last_contrast*100)/255));
          m_contrast_percent.SetWindowText(string);
          //The backlight
          m_backlight.SetPos(last_backlight=incoming_response.data[14]);
          sprintf(string,"%d%%",last_backlight);
          m_backlight_percent.SetWindowText(string);
          break;
        case (0x40|35):  //Return packet from Read GPIO pin levels and configuration state
          //Send the packet up to the GPIO window
          m_pGPIO->OnReceivedState(&incoming_response);
          break;
        case (0x40|27):  //Return packet from Query Fan Power & fail-safe mask
          //Send the packet up to the Fan window.
          m_pFansDlg->OnReceivedFanPower(&incoming_response);
          break;
        case (0x40|10):  //Return packet from Read 8 bytes of LCD memory
          static char
            LCD_Image[4][20*4+1]; //worst case for "/xxx" in all positions
          switch(incoming_response.data[0])
            {
            case 128:    //first line, left
              Copy_And_Encode_String(&LCD_Image[0][0],
                                     &incoming_response.data[1],
                                     8);
              break;
            case 128+8:  //first line, center
              Copy_And_Encode_String(&LCD_Image[0][strlen(&LCD_Image[0][0])],
                                     &incoming_response.data[1],
                                     8);
              break;
            case 128+16: //first line, right
              Copy_And_Encode_String(&LCD_Image[0][strlen(&LCD_Image[0][0])],
                                     &incoming_response.data[1],
                                     4);
              //Update the edit fields with the module's LCD's contents
              m_LCD_Line_1.SetWindowText(LCD_Image[0]);
              break;

            case 192:    //second line, left
              Copy_And_Encode_String(&LCD_Image[1][0],
                                     &incoming_response.data[1],
                                     8);
              break;
            case 192+8:  //second line, center
              Copy_And_Encode_String(&LCD_Image[1][strlen(&LCD_Image[1][0])],
                                     &incoming_response.data[1],
                                     8);
              break;
            case 192+16: //second line, right
              Copy_And_Encode_String(&LCD_Image[1][strlen(&LCD_Image[1][0])],
                                     &incoming_response.data[1],
                                     4);
              //Update the edit fields with the module's LCD's contents
              m_LCD_Line_2.SetWindowText(LCD_Image[1]);
              break;

            }
          break;
        }

      if(!spinner_has_been_updated)
        m_pPacket_Debug->RollAcknowledgeSpinner();
      }

    COMMAND_PACKET
      command_to_LCD;
    switch(update_state)
      {
      case UPDATE_STATE_VERSION:
        m_comm_status.SetWindowText("Looking for module . . .");
        //Send a firmware version request.
        command_to_LCD.command=1;
        command_to_LCD.data_length=0;
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
        update_state=UPDATE_STATE_VERSION_REPLY;
        update_state_timer=30; //300mS
        break;
      case UPDATE_STATE_VERSION_REPLY:
        update_state_timer--;
        if(!update_state_timer)
          update_state=UPDATE_STATE_VERSION;
        break;
      case UPDATE_STATE_MODULE_FOUND:
        //Send a Read 8 bytes of LCD memory request.
        command_to_LCD.command=10;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=128; //first line, left
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Read 8 bytes of LCD memory request.
        command_to_LCD.command=10;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=128+8; //first line, center
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Read 8 bytes of LCD memory request.
        command_to_LCD.command=10;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=128+16; //first line, right
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Read 8 bytes of LCD memory request.
        command_to_LCD.command=10;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=192; //second line, left
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Read 8 bytes of LCD memory request.
        command_to_LCD.command=10;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=192+8; //second line, center
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Read 8 bytes of LCD memory request.
        command_to_LCD.command=10;
        command_to_LCD.data_length=1;
        command_to_LCD.data[0]=192+16; //second line, right
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Query Fan Power & fail-safe mask request.
        command_to_LCD.command=27;
        command_to_LCD.data_length=0;
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Send a Read Reporting Status request.
        command_to_LCD.command=30;
        command_to_LCD.data_length=0;
        //this does the CRC and sends it.
        m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

        //Let the temperature dialog get in on the fun
        m_pTempsDlg->LCDModuleBootComplete();
        //and the GPIO dialog
        m_pGPIO->LCDModuleBootComplete();

        //The initialization is complete.
        update_state=UPDATE_STATE_IDLE;
        break;
      }

    //Expire any any packets that may have been waiting too long
    //for their acknowedges.
    m_pPacket_Debug->Timeout_No_Repsonse_Packets();
    }
  // default processing
  CDialog::OnTimer(nIDEvent);
  }
/////////////////////////////////////////////////////////////////////////////
//  Parameters: int iTimeInterval - timer resolution in miliseconds.
//  max resolution is 55 ms.
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::StartTimer (int iTimeInterval)
  {
  // here we go...
  SetTimer (ID_TIMER1, iTimeInterval, NULL);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::StopTimer (void)
  {
  // kill the timer
  KillTimer (ID_TIMER1);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
  {
  int
    new_contrast;
  char
    string[10];
  COMMAND_PACKET
    command_to_LCD;
  new_contrast=m_contrast.GetPos();
  if(last_contrast!=new_contrast)
    {
    command_to_LCD.command=13;
    command_to_LCD.data[0]=new_contrast;
    command_to_LCD.data_length=1;

    //this does the CRC and sends it.
    m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
    sprintf(string,"%d%%",((last_contrast*100)/255));
    m_contrast_percent.SetWindowText(string);
    last_contrast=new_contrast;
    }

  int
    new_backlight;
  new_backlight=m_backlight.GetPos();
  if(last_backlight!=new_backlight)
    {
    command_to_LCD.command=14;
    command_to_LCD.data[0]=new_backlight;
    command_to_LCD.data_length=1;

    //this does the CRC and sends it.
    m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

    sprintf(string,"%d%%",new_backlight);
    m_backlight_percent.SetWindowText(string);

    last_backlight=new_backlight;
    }
  CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnSendLcdLine1() 
  {
  char
    string[160];
  COMMAND_PACKET
    command_to_LCD;
  //Get the string
  m_LCD_Line_1.GetWindowText(string,160);

  command_to_LCD.command=31;
  command_to_LCD.data[0]=0; //col  = x = 0
  command_to_LCD.data[1]=0; //row  = y = 0
  //Convert escape sequences & copy into &data[2]
  command_to_LCD.data_length=
    m_pPacket_Debug->Convert_Input_String_To_Array(
      string,
      &command_to_LCD.data[2]);
  //Pad it out with spaces
  if(20<command_to_LCD.data_length)
    command_to_LCD.data_length=20;
  else
    while(command_to_LCD.data_length<20)
      command_to_LCD.data[2+command_to_LCD.data_length++]=' ';
  //Account for col & row
  command_to_LCD.data_length+=2;

  //Send it to the 631.
  //this does the CRC and sends it.
  m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnSendLcdLine2() 
  {
  char
    string[160];
  //Get the string
  m_LCD_Line_2.GetWindowText(string,160);

  COMMAND_PACKET
    command_to_LCD;

  command_to_LCD.command=31;
  command_to_LCD.data[0]=0; //col  = x = 0
  command_to_LCD.data[1]=1; //row  = y = 1
  //Convert escape sequences & copy into &data[2]
  command_to_LCD.data_length=
    m_pPacket_Debug->Convert_Input_String_To_Array(
      string,
      &command_to_LCD.data[2]);
  //Pad it out with spaces
  if(20<command_to_LCD.data_length)
    command_to_LCD.data_length=20;
  else
    while(command_to_LCD.data_length<20)
      command_to_LCD.data[2+command_to_LCD.data_length++]=' ';
  //Account for col & row
  command_to_LCD.data_length+=2;

  //Send it to the 631.
  //this does the CRC and sends it.
  m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
  }
/////////////////////////////////////////////////////////////////////////////
//Called by daughter windows to communicate with the LCD module. Basically
//a non protected call to the protected Queue_Outgoing_Packet so
//m_pPacket_Debug does not have to be public.
void CMy631_WinTestDlg::QueuePacket(COMMAND_PACKET *packet)
  {
  //this does the CRC and sends it.
  m_pPacket_Debug->Queue_Outgoing_Packet(packet);
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnEnableLogFans() 
  {
  if(m_enable_log_fans.GetCheck())
    {
    //just got checked, start logging.
    log_count=0;
    if(fan_log)
      fclose(fan_log);
    fan_log=fopen("631_log.csv","at");
    if(fan_log)
      {
      //Get the string
      CString
        input_string;
      char
        string[160];
      m_LCD_Line_1.GetWindowText(input_string);
      strcpy(string,(LPSTR)(const char *)input_string);
      fprintf(fan_log,"//Logging started. L1=\"%s\" ",string);
      m_LCD_Line_2.GetWindowText(input_string);
      strcpy(string,(LPSTR)(const char *)input_string);
      fprintf(fan_log,"L2=\"%s\"\n",string);
      fprintf(fan_log,"\"Date\",\"Time\",");

      int
        i;
      for(i=1;i<=4;i++)
        fprintf(fan_log,"\"Fan %d\",",i);
      for(i=1;i<=32;i++)
        fprintf(fan_log,"\"Temp %2d\"%s",i,i==32?"\n":",");
      for(i=0;i<=7;i++)
        log_line.fans_have_data[i]=0;
      for(i=0;i<=31;i++)
        log_line.temps_have_data[i]=0;
      }
    else
      m_enable_log_fans.SetCheck(0);
    }
   else
    {
    //just got un-checked, stop logging.
    if(fan_log)
      {
      fclose(fan_log);
      fan_log=NULL;
      }
    
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnCloseupPortCombo() 
  {
  if(m_port.GetCurSel()!=-1)
    set_serial(m_port.GetCurSel());
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnDropdownPortCombo() 
  {
  //Close the port
  Uninit_Serial();
  //Remember what is open
  int
    port;
  port=m_port.GetCurSel();
  //Re-enumerate
  Find_Serial_Ports();
  //Pre-select what was open
  m_port.SetCurSel(port);
  }
/////////////////////////////////////////////////////////////////////////////
//should move to live_display.cpp
void CMy631_WinTestDlg::Send_Live_Data_To_Display(void)
  {
  COMMAND_PACKET
    command_to_LCD;
  int
    slot;
  for(slot=0;slot<=3;slot++)
    {
    //Build up the packet
    command_to_LCD.command=21;
    command_to_LCD.data[0]=slot;
    command_to_LCD.data[1]=live[slot].type;
    if(live[slot].type)
      {
      command_to_LCD.data_length=7;
      command_to_LCD.data[2]=live[slot].index;
      command_to_LCD.data[3]=live[slot].digits;
      command_to_LCD.data[4]=live[slot].column;
      command_to_LCD.data[5]=live[slot].row;
      command_to_LCD.data[6]=live[slot].units;
      }
    else
      command_to_LCD.data_length=2;
    //Send it to the Display.
    //this does the CRC and sends it.
    m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
    Sleep(5);
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnBaud19200() 
  {
  COMMAND_PACKET
    command_to_LCD;
  m_baud_19200.SetCheck(1);
  m_baud_115200.SetCheck(0);
  //Send the "Change baud to 19200" packet to the CFA-631
  command_to_LCD.command=33;
  command_to_LCD.data[0]=0;
  command_to_LCD.data_length=1;
  //this does the CRC and sends it.
  m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
  //Give time tor the CFA-631 to respond, and show the return
  //packet (properly we should wait for the ack)
  for(int i=0;i<=100;i++)
    {
    Sleep(2);
    OnTimer(ID_TIMER1);
    }

  //Change our speed
  Uninit_Serial();
  set_serial(m_port.GetCurSel());
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnBaud115200() 
  {
  COMMAND_PACKET
    command_to_LCD;
  m_baud_19200.SetCheck(0);
  m_baud_115200.SetCheck(1);
  //Send the "Change baud to 115200" packet to the CFA-631
  command_to_LCD.command=33;
  command_to_LCD.data[0]=1;
  command_to_LCD.data_length=1;
  //this does the CRC and sends it.
  m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
  //Give time tor the CFA-631 to respond, and show the return
  //packet (properly we should wait for the ack)
  for(int i=0;i<=100;i++)
    {
    Sleep(2);
    OnTimer(ID_TIMER1);
    }

  //Change our speed
  Uninit_Serial();
  set_serial(m_port.GetCurSel());
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnCharacterSet() 
  {
  int
    line;
  int
    col;
  int
    set;
  //Disable key legends
  COMMAND_PACKET
    command_to_LCD;
  command_to_LCD.command=32;
  command_to_LCD.data[0]=0;
  command_to_LCD.data_length=1;
  m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);

  for(set=0;set<=7;set++)
    {
    for(line=0;line<=1;line++)
      {
      command_to_LCD.command=31;
      command_to_LCD.data[0]=0;    //col  = x = 0
      command_to_LCD.data[1]=line; //row  = y = 0 or 1
      sprintf((char *)&command_to_LCD.data[2],"%03d:",line*8+set*32);
      for(col=0;col<=15;col++)
        command_to_LCD.data[6+col]=line*16+set*32+col;
      command_to_LCD.data_length=22;
      //this does the CRC and sends it.
      m_pPacket_Debug->Queue_Outgoing_Packet(&command_to_LCD);
      }
    if(set!=7)
      {
      char
        message[100];
      sprintf(message,
              "Displaying screen %d of 8, characters %d through %d. Click OK to see next set.",
              set+1,set*32,set*32+31);
      MessageBox(message,"CFA-631 Character Set", MB_ICONINFORMATION);
      }
    }
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnChangeLcdLine1() 
  {
  if(m_auto_update.GetCheck())
    OnSendLcdLine1();     
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnChangeLcdLine2() 
  {
  if(m_auto_update.GetCheck())
    OnSendLcdLine2();     
  }
/////////////////////////////////////////////////////////////////////////////
void CMy631_WinTestDlg::OnAutoUpdate() 
  {
  if(m_auto_update.GetCheck())
    {
    OnSendLcdLine1();     
    OnSendLcdLine2();     
	  }
  }
/////////////////////////////////////////////////////////////////////////////
