//============================================================================
// 631_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
// 631_WinTestDlg.h : header file
//

#if !defined(AFX_631_WINTESTDLG_H__E0E13B84_E9DC_4F3C_84AC_EEF4AA15262D__INCLUDED_)
#define AFX_631_WINTESTDLG_H__E0E13B84_E9DC_4F3C_84AC_EEF4AA15262D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMy631_WinTestDlg dialog

//keeps track of the boot/update process
#define UPDATE_STATE_IDLE                    0
#define UPDATE_STATE_VERSION                 1
#define UPDATE_STATE_VERSION_REPLY           2
#define UPDATE_STATE_LCD_0                   3
#define UPDATE_STATE_LCD_0_REPLY             4
#define UPDATE_STATE_LCD_1                   5
#define UPDATE_STATE_LCD_1_REPLY             6
#define UPDATE_STATE_LCD_2                   7
#define UPDATE_STATE_LCD_2_REPLY             8
#define UPDATE_STATE_LCD_3                   9
#define UPDATE_STATE_LCD_3_REPLY             10
#define UPDATE_STATE_MODULE_FOUND            11


typedef struct
  {
  unsigned char type;
  unsigned char index;
  unsigned char digits;
  unsigned char column;
  unsigned char row;
  unsigned char units;
  } LIVE_DISPLAY_STRUCT;

typedef struct
  {
  unsigned char index;
  unsigned char output;
  unsigned char function;
  } GPIO_STRUCT;

class CMy631_WinTestDlg : public CDialog
{
// Construction
public:
  CMy631_WinTestDlg(CWnd* pParent = NULL);  // standard constructor

  //These functions allow us to re-enable our buttons.
  void CMy631_WinTestDlg::Packet_Debugger_Done(void);
  void CMy631_WinTestDlg::Live_Display_Done(void);
  void CMy631_WinTestDlg::GPIO_Done(void);
  void CMy631_WinTestDlg::KeyPads_Done(void);
  void CMy631_WinTestDlg::TempsDlg_Done(void);
  void CMy631_WinTestDlg::FansDlg_Done(void);
  void CMy631_WinTestDlg::LED_Editor_Done(void);

  //This function allows the dialogs to sent packets
  void CMy631_WinTestDlg::QueuePacket(COMMAND_PACKET *packet);

  //these should move to Live_Display
  void CMy631_WinTestDlg::Send_Live_Data_To_Display(void);
  LIVE_DISPLAY_STRUCT CMy631_WinTestDlg::live[8];

  //these should move to GPIO
  GPIO_STRUCT CMy631_WinTestDlg::gpio[5];

  //public for TempsDlg::OnRebootToRedetect()
  int update_state;
  //public for TempsDlg::OnReceivedTempReport()
  void CMy631_WinTestDlg::log_temp(int index,double temp,int data_good);

  //public for FansDlg::OnReceivedFanReport()
  void CMy631_WinTestDlg::log_fan(int index,int rpm);

  //public for Packet_Debug::Set_Received_User_Text()
  //to access FansDlg::get_fan()
  FansDlg* m_pFansDlg;

  //public for TempsDlg::OnReceivedReportingStatus()
  //to access GPIO::TemperatureInitializationComplete()
  GPIO* m_pGPIO;

// Dialog Data
  //{{AFX_DATA(CMy631_WinTestDlg)
	enum { IDD = IDD_MY631_WINTEST_DIALOG };
	CButton	m_auto_update;
  CComboBox m_port;
  CButton m_baud_19200;
  CButton m_baud_115200;
  CEdit m_comm_status;
  CButton m_enable_log_fans;
  CSliderCtrl m_backlight;
  CSliderCtrl m_contrast;
  CEdit m_contrast_percent;
  CEdit m_backlight_percent;
  CEdit m_LCD_Line_2;
  CEdit m_LCD_Line_1;
	//}}AFX_DATA

  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CMy631_WinTestDlg)
  protected:
  virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV support
  //}}AFX_VIRTUAL

// Implementation
protected:
  HICON m_hIcon;
  KeyPads* m_pKeyPads;
  TempsDlg* m_pTempsDlg;
  Live_Display* m_pLive_Display;
  Packet_Debug* m_pPacket_Debug;
  LED_Editor* m_pLED_Editor;

  unsigned char last_glitch_settings[4];
  void CMy631_WinTestDlg::OnSendPacket(void);
  void CMy631_WinTestDlg::Copy_And_Encode_String(char *out,const unsigned char *in,int length);
  void CMy631_WinTestDlg::flush_log_line(void);
  void CMy631_WinTestDlg::OnTimer(UINT nIDEvent);
  void CMy631_WinTestDlg::StartTimer (int iTimeInterval);
  void CMy631_WinTestDlg::StopTimer (void);
  void CMy631_WinTestDlg::Find_Serial_Ports(void);
  void CMy631_WinTestDlg::set_serial(int port);
  int last_contrast;
  int last_backlight;
  int update_state_timer;
  // Generated message map functions
  //{{AFX_MSG(CMy631_WinTestDlg)
  virtual BOOL OnInitDialog();
  afx_msg HCURSOR OnQueryDragIcon();
  afx_msg void OnBaud115200();
  afx_msg void OnBaud19200();
  afx_msg void OnCloseupPortCombo();
  afx_msg void OnDropdownPortCombo();
  afx_msg void OnEnableLogFans();
  afx_msg void OnGPIO();
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg void OnFans();
  afx_msg void OnKeyPads();
  afx_msg void OnLiveDisplay();
  afx_msg void OnPacketDebugger();
  afx_msg void OnPaint();
  afx_msg void OnSendLcdLine1();
  afx_msg void OnSendLcdLine2();
  afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
  afx_msg void OnTemperatures();
  afx_msg void OnExit();
	afx_msg void OnLed();
	afx_msg void OnCharacterSet();
	afx_msg void OnChangeLcdLine1();
	afx_msg void OnChangeLcdLine2();
	afx_msg void OnAutoUpdate();
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_631_WINTESTDLG_H__E0E13B84_E9DC_4F3C_84AC_EEF4AA15262D__INCLUDED_)
