//============================================================================
// 631_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
// Fans.cpp : implementation file
//

#include "stdafx.h"
#include "631_wintest.h"
#include "serial.h"
#include "GPIO.h"
#include "KeyPads.h"
#include "TempsDlg.h"
#include "Fans.h"
#include "Packet_Debug.h"
#include "Live_Display.h"
#include "LED_Editor.h"
#include "631_WinTestDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
#define POLL_INTERVAL 100 // 1/10 sec
#define ID_TIMER3     3
/////////////////////////////////////////////////////////////////////////////
// Fans dialog
FansDlg::FansDlg(CWnd* pParent /*=NULL*/)
  : CDialog(FansDlg::IDD, pParent)
  {
  //{{AFX_DATA_INIT(FansDlg)
  //}}AFX_DATA_INIT
  ASSERT(pParent != NULL);

  m_pParent = pParent;
  m_nID = FansDlg::IDD;
  } 

BOOL FansDlg::OnInitDialog()
  {
  CDialog::OnInitDialog();

  int
    fan;
  for(fan=0;fan<=3;fan++)
    {
    time_since_new_data[fan]=0;

    //Set the control's default position
    char
      string[10];

    m_fan_power_slider[fan].SetRange(0,100);
    m_fan_power_slider[fan].SetPos(100-(last_fan_power[fan]=100));
    sprintf(string,"%d%%",last_fan_power[fan]);
    m_fan_power_percent[fan].SetWindowText(string);

    m_fan_rpm_display[fan].SetWindowText("");
    m_fan_RPM_bar[fan].SetRange(0,fan_max_rpm[fan]=1000);
    m_fan_rpm_scale[fan].SetWindowText("");
    m_fan_RPM_bar[fan].SetPos(0);
    m_fan_enable_tach[fan].SetCheck(0);
    m_fan_PPR[fan].SetCurSel(1);
    m_fan_glitch[fan].SetCurSel(0);
    last_glitch_settings[fan]=1;

    int
      i;
    for(i=0;i<=(FAN_HISTORY_LENGTH-1);i++)
      fan_rpm_history[fan][i]=0;
    }
  StartTimer(POLL_INTERVAL);

  return TRUE;
  }

void FansDlg::DoDataExchange(CDataExchange* pDX)
  {
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(FansDlg)
  DDX_Control(pDX, IDC_FAN_1_GLITCH,     m_fan_glitch[0]);
  DDX_Control(pDX, IDC_FAN_1_PERCENT,    m_fan_power_percent[0]);
  DDX_Control(pDX, IDC_FAN_1_POWER,      m_fan_power_slider[0]);
  DDX_Control(pDX, IDC_FAN_1_PPR,        m_fan_PPR[0]);
  DDX_Control(pDX, IDC_FAN_1_RPM,        m_fan_rpm_display[0]);
  DDX_Control(pDX, IDC_FAN_1_RPM_ENABLE, m_fan_enable_tach[0]);
  DDX_Control(pDX, IDC_FAN_1_RPM_SCALE,  m_fan_rpm_scale[0]);
  DDX_Control(pDX, IDC_FAN_RPM_BAR_1,    m_fan_RPM_bar[0]);
  DDX_Control(pDX, IDC_SMOOTH_FAN_1,     m_smooth_fan[0]);
  DDX_Control(pDX, IDC_FAN_2_GLITCH,     m_fan_glitch[1]);
  DDX_Control(pDX, IDC_FAN_2_PERCENT,    m_fan_power_percent[1]);
  DDX_Control(pDX, IDC_FAN_2_POWER,      m_fan_power_slider[1]);
  DDX_Control(pDX, IDC_FAN_2_PPR,        m_fan_PPR[1]);
  DDX_Control(pDX, IDC_FAN_2_RPM,        m_fan_rpm_display[1]);
  DDX_Control(pDX, IDC_FAN_2_RPM_ENABLE, m_fan_enable_tach[1]);
  DDX_Control(pDX, IDC_FAN_2_RPM_SCALE,  m_fan_rpm_scale[1]);
  DDX_Control(pDX, IDC_FAN_RPM_BAR_2,    m_fan_RPM_bar[1]);
  DDX_Control(pDX, IDC_SMOOTH_FAN_2,     m_smooth_fan[1]);
  DDX_Control(pDX, IDC_FAN_3_GLITCH,     m_fan_glitch[2]);
  DDX_Control(pDX, IDC_FAN_3_PERCENT,    m_fan_power_percent[2]);
  DDX_Control(pDX, IDC_FAN_3_POWER,      m_fan_power_slider[2]);
  DDX_Control(pDX, IDC_FAN_3_PPR,        m_fan_PPR[2]);
  DDX_Control(pDX, IDC_FAN_3_RPM,        m_fan_rpm_display[2]);
  DDX_Control(pDX, IDC_FAN_3_RPM_ENABLE, m_fan_enable_tach[2]);
  DDX_Control(pDX, IDC_FAN_3_RPM_SCALE,  m_fan_rpm_scale[2]);
  DDX_Control(pDX, IDC_FAN_RPM_BAR_3,    m_fan_RPM_bar[2]);
  DDX_Control(pDX, IDC_SMOOTH_FAN_3,     m_smooth_fan[2]);
  DDX_Control(pDX, IDC_FAN_4_GLITCH,     m_fan_glitch[3]);
  DDX_Control(pDX, IDC_FAN_4_PERCENT,    m_fan_power_percent[3]);
  DDX_Control(pDX, IDC_FAN_4_POWER,      m_fan_power_slider[3]);
  DDX_Control(pDX, IDC_FAN_4_PPR,        m_fan_PPR[3]);
  DDX_Control(pDX, IDC_FAN_4_RPM,        m_fan_rpm_display[3]);
  DDX_Control(pDX, IDC_FAN_4_RPM_ENABLE, m_fan_enable_tach[3]);
  DDX_Control(pDX, IDC_FAN_4_RPM_SCALE,  m_fan_rpm_scale[3]);
  DDX_Control(pDX, IDC_FAN_RPM_BAR_4,    m_fan_RPM_bar[3]);
  DDX_Control(pDX, IDC_SMOOTH_FAN_4,     m_smooth_fan[3]);
  //}}AFX_DATA_MAP
  }

//Allows both ON_WM_CLOSE and ON_BN_CLICKED(IDC_HIDE_FANS, ) to map to
//a single function with out breaking the resource editor,
#define OnDone OnClose

BEGIN_MESSAGE_MAP(FansDlg, CDialog)
  //{{AFX_MSG_MAP(FansDlg)
  ON_CBN_CLOSEUP(IDC_FAN_1_GLITCH, OnCloseupFan1Glitch)
  ON_CBN_CLOSEUP(IDC_FAN_2_GLITCH, OnCloseupFan2Glitch)
  ON_CBN_CLOSEUP(IDC_FAN_3_GLITCH, OnCloseupFan3Glitch)
  ON_CBN_CLOSEUP(IDC_FAN_4_GLITCH, OnCloseupFan4Glitch)
  ON_CBN_EDITCHANGE(IDC_FAN_1_GLITCH, OnEditChangeFanGlitch)
  ON_BN_CLICKED(IDC_FAN_1_RPM_ENABLE, OnFanRPMEnable)
  ON_WM_VSCROLL()
  ON_WM_CLOSE()
  ON_BN_CLICKED(IDC_FAN_2_RPM_ENABLE, OnFanRPMEnable)
  ON_BN_CLICKED(IDC_FAN_3_RPM_ENABLE, OnFanRPMEnable)
  ON_BN_CLICKED(IDC_FAN_4_RPM_ENABLE, OnFanRPMEnable)
  ON_CBN_EDITCHANGE(IDC_FAN_2_GLITCH, OnEditChangeFanGlitch)
  ON_CBN_EDITCHANGE(IDC_FAN_3_GLITCH, OnEditChangeFanGlitch)
  ON_CBN_EDITCHANGE(IDC_FAN_4_GLITCH, OnEditChangeFanGlitch)
  ON_CBN_SELCHANGE(IDC_FAN_1_GLITCH, OnCloseupFan1Glitch)
  ON_CBN_SELCHANGE(IDC_FAN_2_GLITCH, OnCloseupFan2Glitch)
  ON_CBN_SELCHANGE(IDC_FAN_3_GLITCH, OnCloseupFan3Glitch)
  ON_CBN_SELCHANGE(IDC_FAN_4_GLITCH, OnCloseupFan4Glitch)
  ON_BN_CLICKED(IDC_HIDE_FANS, OnDone)
  ON_WM_TIMER()
  ON_BN_CLICKED(IDC_SMOOTH_FAN_1, OnSmoothFan)
  ON_BN_CLICKED(IDC_SMOOTH_FAN_2, OnSmoothFan)
  ON_BN_CLICKED(IDC_SMOOTH_FAN_3, OnSmoothFan)
  ON_BN_CLICKED(IDC_SMOOTH_FAN_4, OnSmoothFan)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// Fans message handlers
/////////////////////////////////////////////////////////////////////////////
BOOL FansDlg::Create(void)
  {
  return CDialog::Create(m_nID, m_pParent);
  }
/////////////////////////////////////////////////////////////////////////////
void FansDlg::PostNcDestroy(void)
  {
  delete this;
  }
/////////////////////////////////////////////////////////////////////////////
void FansDlg::OnClose(void) 
  {
  ((CMy631_WinTestDlg*)m_pParent)->FansDlg_Done();
  }
/////////////////////////////////////////////////////////////////////////////
//  Parameters: int iTimeInterval - timer resolution in miliseconds.
//  max resolution is 55 ms.
/////////////////////////////////////////////////////////////////////////////
void FansDlg::StartTimer (int iTimeInterval)
  {
  // here we go...
  SetTimer(ID_TIMER3, iTimeInterval, NULL);
  }
/////////////////////////////////////////////////////////////////////////////
void FansDlg::StopTimer (void)
  {
  // kill the timer
  KillTimer(ID_TIMER3);
  }
/////////////////////////////////////////////////////////////////////////////
int FansDlg::get_fan(COMMAND_PACKET *packet, char * output)
  {
  int
    return_value;
  return_value=0;

  int
    number_of_fan_tach_cycles;
  number_of_fan_tach_cycles=packet->data[1];

  if(number_of_fan_tach_cycles<3)
    sprintf(output," STOP");
  else if(number_of_fan_tach_cycles<4)
    sprintf(output," SLOW");
  else if(0xFF==number_of_fan_tach_cycles)
    sprintf(output," ----");
  else
    {
    int
      pulses_per_revolution;

    //have gotten a debug assertion here
    pulses_per_revolution=m_fan_PPR[packet->data[0]].GetCurSel()+1;

    int
      Fan_Timer_Ticks;
    Fan_Timer_Ticks=(*(WORD *)(&(packet->data[2])));

    return_value=((27692308L/pulses_per_revolution)*
                  (unsigned long)(number_of_fan_tach_cycles-3))/
                 (Fan_Timer_Ticks);
    sprintf(output,"%5d",return_value);
    }
  return(return_value);
  }
/////////////////////////////////////////////////////////////////////////////
int FansDlg::smooth_fan(int fan_index,
                        int new_rpm,
                        char * output)
  {
  //First shift the history.
  int
    i;
  for(i=7;1<=i;i--)
    fan_smooth_history[fan_index][i]=fan_smooth_history[fan_index][i-1];
  fan_smooth_history[fan_index][0]=new_rpm;
  //Now get filtered RPM.
  double
    smoothed_rpm;
  const static double
    scales[8]={1.0,1.0,0.95,0.9,0.8,0.6,0.4,0.2};
  smoothed_rpm=0.0;
  for(i=0;i<=7;i++)
    smoothed_rpm+=((double)fan_smooth_history[fan_index][i])*scales[i];
  smoothed_rpm=(smoothed_rpm/5.85) + 0.5;

  int
    return_value;
  return_value=(int)smoothed_rpm;
  sprintf(output,"%5d",return_value);
  return(return_value);
  }
/////////////////////////////////////////////////////////////////////////////
void FansDlg::OnTimer(UINT nIDEvent) 
  {
  if (nIDEvent == ID_TIMER3)
    {
    //Blank any displays that have not been updated in
    //the last 0.7 seconds.
    int
      fan;
    for(fan=0;fan<=3;fan++)
      {
      if(time_since_new_data[fan])
        {
        time_since_new_data[fan]--;
        if(!time_since_new_data[fan])
          {
          m_fan_rpm_display[fan].SetWindowText(" - - ");
          m_fan_rpm_scale[fan].SetWindowText(" - - ");
          m_fan_RPM_bar[fan].SetRange(0,fan_max_rpm[fan]=1);
          m_fan_RPM_bar[fan].SetPos(0);
          }
        }
      }
    }
  // default processing
  CDialog::OnTimer(nIDEvent);
  }
/////////////////////////////////////////////////////////////////////////////
int FansDlg::Get_Fan_Scale(int fan_speed,int old_max_rpm, int fan_rpm_history[])
  {
  //First shift the history.
  int
    i;
  for(i=(FAN_HISTORY_LENGTH-1);1<=i;i--)
    fan_rpm_history[i]=fan_rpm_history[i-1];
  fan_rpm_history[0]=fan_speed;
  int
    max_rpm;
  max_rpm=0;
  //Now get the maximum speed of the last 10 seconds.
  for(i=1;i<=(FAN_HISTORY_LENGTH-1);i++)
    if(max_rpm<fan_rpm_history[i])
      max_rpm=fan_rpm_history[i];
  //Now make it reasonable in a 1,2,5 fashion, with some hysteresis.
  static const int
    scale[9]={1000,2000,5000,10000,20000,50000,100000,500000,1000000};
  int
    new_max_rpm_index;
  new_max_rpm_index=0;
  for(i=0;i<=8;i++)
    if(max_rpm<=scale[i])
      {
      new_max_rpm_index=i;
      break;
      }

  int
    old_max_rpm_index;
  old_max_rpm_index=0;
  for(i=0;i<=8;i++)
    if(old_max_rpm<=scale[i])
      {
      old_max_rpm_index=i;
      break;
      }

  //If the new_max_rpm is one less tban old_max_rpm, only drop to the new,
  //lower range if the max_rpm is less than 75% of the new range.
  if((new_max_rpm_index==(old_max_rpm_index-1))&&
     (((scale[new_max_rpm_index]*3)/4)<max_rpm))
    new_max_rpm_index=old_max_rpm_index;
    
  return(scale[new_max_rpm_index]);
  }
/////////////////////////////////////////////////////////////////////////////
void FansDlg::OnReceivedFanReport(COMMAND_PACKET *packet)
  {
  char
    fan_string[20];
  int
    fan_speed;
  int
    new_fan_max_rpm;
  int
    old_low_range;
  int
    old_high_range;
  fan_speed=get_fan(packet,fan_string);

  int
    fan;
  fan=packet->data[0];

  //Do the smoothing first if it is enabled,
  if(m_smooth_fan[fan].GetCheck())
    fan_speed=smooth_fan(fan,fan_speed,fan_string);

  //This logs the smoothed speed, or raw depending on the check box.
  ((CMy631_WinTestDlg*)m_pParent)->log_fan(fan,fan_speed);

  m_fan_rpm_display[fan].SetWindowText(fan_string);
  m_fan_RPM_bar[fan].GetRange(old_low_range,old_high_range);
  new_fan_max_rpm=Get_Fan_Scale(fan_speed,
                                old_high_range,
                                fan_rpm_history[fan]);
  if(new_fan_max_rpm!=fan_max_rpm[fan])
    {
    m_fan_RPM_bar[fan].SetRange32(0,fan_max_rpm[fan]=new_fan_max_rpm);
    sprintf(fan_string,"%d",fan_max_rpm[fan]);
    m_fan_rpm_scale[fan].SetWindowText(fan_string);
    }
  m_fan_RPM_bar[fan].SetPos(fan_speed);

  //1/10 of a second * 7 = a bit over 1/2 second 
  time_since_new_data[fan]=7;
  }
////////////////////////////////////////////////////////////////////////////
void FansDlg::OnReceivedReportingStatus(COMMAND_PACKET *packet)
  {
  int
    fan;
  unsigned char
    mask;
  for(fan=0,mask=0x01;fan<=3;fan++,mask<<=1)
    {
    //Set the fan glitch
    char
      string[20];
    sprintf(string,"%d",last_glitch_settings[fan]=packet->data[fan+9]);
    m_fan_glitch[fan].SetWindowText(string);
    //Set our fan checks
    m_fan_enable_tach[fan].SetCheck((packet->data[0]&mask)?1:0);
    }
  }
////////////////////////////////////////////////////////////////////////////
void FansDlg::OnReceivedFanPower(COMMAND_PACKET *packet)
  {
  int
    fan;
  for(fan=0;fan<=3;fan++)
    {
    char
      string[20];
    //Update fan power sliders & percents
    last_fan_power[fan]=packet->data[fan];
    m_fan_power_slider[fan].SetPos(100-last_fan_power[fan]);
    sprintf(string,"%d%%",last_fan_power[fan]);
    m_fan_power_percent[fan].SetWindowText(string);
    }
  }
/////////////////////////////////////////////////////////////////////////////
void FansDlg::OnFanRPMEnable(void) 
  {
  COMMAND_PACKET
    set_fan_report_packet;
  //Build up the command packet and send over to the 631.
  set_fan_report_packet.command=16;
  set_fan_report_packet.data[0]=0;

  int
    fan;
  unsigned char
    mask;
  for(fan=0,mask=0x01;fan<=3;fan++,mask<<=1)
    if(m_fan_enable_tach[fan].GetCheck())
      set_fan_report_packet.data[0]|=mask;

  //Send it to the 631.
  set_fan_report_packet.data_length=1;
  //Send the packet to the module
  ((CMy631_WinTestDlg*)m_pParent)->QueuePacket(&set_fan_report_packet);
  }
/////////////////////////////////////////////////////////////////////////////
void FansDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
  {
  COMMAND_PACKET
    set_fan_power_packet;
  int
    need_to_send_update;
  need_to_send_update=0;

  int
    fan;
  for(fan=0;fan<=3;fan++)
    {
    int
      new_fan_power;

    new_fan_power=100-m_fan_power_slider[fan].GetPos();
    //put it in the packet to send
    set_fan_power_packet.data[fan]=new_fan_power;
    //See if there is a change
    if(last_fan_power[fan]!=new_fan_power)
      {
      //remember the change
      last_fan_power[fan]=new_fan_power;
      //update the power reading on the screen
      char
        string[10];
      sprintf(string,"%d%%",last_fan_power[fan]);
      m_fan_power_percent[fan].SetWindowText(string);
      //remember that we need to send the change to the LCD module
      need_to_send_update=1;
      }
    }
  if(need_to_send_update)
    {
    //Fill out the rest of the packet's details
    set_fan_power_packet.command=17;
    set_fan_power_packet.data_length=4;
    //Send the packet to the module
    ((CMy631_WinTestDlg*)m_pParent)->QueuePacket(&set_fan_power_packet);
    }

  //Do the default processing
  CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
  }
////////////////////////////////////////////////////////////////////////////
//There has got to be something I'm missing on these combo boxes.
//There is no way they could be this obtuse by design. 

static const char
  *glitch_combobox_data[23]={"1","2","3","4","5","6","7","8","9","10","15",
                             "20","25","30","35","40","45","50","60","70",
                             "80","90","100"};

void FansDlg::OnCloseupFan1Glitch() 
  {
  m_fan_glitch[0].SetWindowText(glitch_combobox_data[m_fan_glitch[0].GetCurSel()]);
  OnEditChangeFanGlitch();
  }
void FansDlg::OnCloseupFan2Glitch() 
  {
  m_fan_glitch[1].SetWindowText(glitch_combobox_data[m_fan_glitch[1].GetCurSel()]);
  OnEditChangeFanGlitch();
  }
void FansDlg::OnCloseupFan3Glitch() 
  {
  m_fan_glitch[2].SetWindowText(glitch_combobox_data[m_fan_glitch[2].GetCurSel()]);
  OnEditChangeFanGlitch();
  }
void FansDlg::OnCloseupFan4Glitch() 
  {
  m_fan_glitch[3].SetWindowText(glitch_combobox_data[m_fan_glitch[3].GetCurSel()]);
  OnEditChangeFanGlitch();
  }
void FansDlg::OnEditChangeFanGlitch() 
  {
  //We need to read the text fields, validate, then send to the LCD module
  COMMAND_PACKET
    set_fan_glitch_packet;
  int
    need_to_send_update;
  need_to_send_update=0;

  int
    fan;
  for(fan=0;fan<=3;fan++)
    {
    char
      string[20];
    m_fan_glitch[fan].GetWindowText(string,19);
    int
      setting;
    setting=atoi(string);
    if(setting==0)
      {
      setting=1;
      m_fan_glitch[fan].SetWindowText("1");
      }
    else
      if(100<setting)
        {
        setting=100;
        m_fan_glitch[fan].SetWindowText("100");
        }
    set_fan_glitch_packet.data[fan]=setting;

    if(last_glitch_settings[fan]!=set_fan_glitch_packet.data[fan])
      {
      need_to_send_update=1;
      last_glitch_settings[fan]=set_fan_glitch_packet.data[fan];
      }
    }
  if(need_to_send_update)
    {
    //Send it to the 631.
    set_fan_glitch_packet.command=26;
    set_fan_glitch_packet.data_length=4;
    //Send the packet to the module
    ((CMy631_WinTestDlg*)m_pParent)->QueuePacket(&set_fan_glitch_packet);
    }
  }
/////////////////////////////////////////////////////////////////////////////
void FansDlg::OnSmoothFan() 
  {
  int
    fan;
  for(fan=0;fan<=3;fan++)
    if(m_smooth_fan[fan].GetCheck())
      {
      //Pre-load the buffer from the current reading.
      char
        string[20];
      m_fan_rpm_display[fan].GetWindowText(string,29);
      int
        current_reading;
      current_reading=atoi(string);
      int
        i;
      for(i=0;i<=7;i++)
        fan_smooth_history[fan][i]=current_reading;
      }
  }
/////////////////////////////////////////////////////////////////////////////


