//============================================================================
// 631_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
// GPIO.h : header file
//
#if !defined(AFX_GPIO_H__E1DA3834_BD02_4E31_B2B0_801EF407C21B__INCLUDED_)
#define AFX_GPIO_H__E1DA3834_BD02_4E31_B2B0_801EF407C21B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// GPIO dialog

class GPIO : public CDialog
{
// Construction
public:
  GPIO(CWnd* pParent = NULL);   // standard constructor
  BOOL Create();
  virtual BOOL GPIO::OnInitDialog();

  //Called when the temps init is done so we can start our init.
  void GPIO::LCDModuleBootComplete(void);
  //Called by the main window
  void GPIO::OnReceivedState(COMMAND_PACKET *packet);

// Dialog Data
  //{{AFX_DATA(GPIO)
  enum { IDD = IDD_GPIO };
  CComboBox m_drive_mode_gpio_4;
  CComboBox m_drive_mode_gpio_3;
  CComboBox m_drive_mode_gpio_2;
  CComboBox m_drive_mode_gpio_1;
  CComboBox m_drive_mode_gpio_0;
  CEdit m_reading_gpio_4;
  CEdit m_reading_gpio_3;
  CEdit m_reading_gpio_2;
  CEdit m_reading_gpio_1;
  CEdit m_reading_gpio_0;
  CComboBox m_function_gpio_4;
  CComboBox m_function_gpio_3;
  CComboBox m_function_gpio_2;
  CComboBox m_function_gpio_1;
  CComboBox m_function_gpio_0;
  CButton m_full_on_gpio_4;
  CButton m_full_on_gpio_3;
  CButton m_full_on_gpio_2;
  CButton m_full_on_gpio_1;
  CButton m_full_on_gpio_0;
  CButton m_full_off_gpio_3;
  CButton m_full_off_gpio_2;
  CButton m_full_off_gpio_1;
  CButton m_full_off_gpio_4;
  CButton m_full_off_gpio_0;
  CButton m_set_settings_gpio_4;
  CButton m_set_settings_gpio_3;
  CButton m_set_settings_gpio_2;
  CButton m_set_settings_gpio_1;
  CButton m_set_settings_gpio_0;
  CEdit m_pwm_percent_4;
  CEdit m_pwm_percent_3;
  CEdit m_pwm_percent_2;
  CEdit m_pwm_percent_1;
  CEdit m_pwm_percent_0;
  CSliderCtrl m_pwm_slider_4;
  CSliderCtrl m_pwm_slider_3;
  CSliderCtrl m_pwm_slider_2;
  CSliderCtrl m_pwm_slider_1;
  CSliderCtrl m_pwm_slider_0;
  //}}AFX_DATA


// Overrides
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(GPIO)
  protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  virtual void PostNcDestroy();
  //}}AFX_VIRTUAL

// Implementation
protected:
  CWnd* m_pParent;
  int m_nID;

  void GPIO::Send_Update_Packet(int index,int power,int function,int drive_mode);
  void GPIO::Send_Update_Power_Packet(int index,int power);
  void GPIO::Send_Reading_Request_Packet(int index);

  void GPIO::Enable_Output_Controls_GPIO_0(int state);
  void GPIO::Enable_Output_Controls_GPIO_1(int state);
  void GPIO::Enable_Output_Controls_GPIO_2(int state);
  void GPIO::Enable_Output_Controls_GPIO_3(int state);
  void GPIO::Enable_Output_Controls_GPIO_4(int state);

  //These variables are used to detect what changed when an hscroll happens
  int output_0;
  int output_1;
  int output_2;
  int output_3;
  int output_4;

  // Generated message map functions
  //{{AFX_MSG(GPIO)
  afx_msg void OnClose();
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg void OnCloseUpFunctionGpio0();
  afx_msg void OnFullOffGpio0();
  afx_msg void OnFullOffGpio1();
  afx_msg void OnFullOffGpio2();
  afx_msg void OnFullOffGpio3();
  afx_msg void OnFullOffGpio4();
  afx_msg void OnFullOnGpio0();
  afx_msg void OnFullOnGpio1();
  afx_msg void OnFullOnGpio2();
  afx_msg void OnFullOnGpio3();
  afx_msg void OnFullOnGpio4();
  afx_msg void OnReadSettingsGpio0();
  afx_msg void OnReadSettingsGpio1();
  afx_msg void OnReadSettingsGpio2();
  afx_msg void OnReadSettingsGpio3();
  afx_msg void OnReadSettingsGpio4();
  afx_msg void OnSetSettingsGpio0();
  afx_msg void OnSetSettingsGpio1();
  afx_msg void OnSetSettingsGpio2();
  afx_msg void OnSetSettingsGpio3();
  afx_msg void OnSetSettingsGpio4();
  afx_msg void OnCloseUpFunctionGpio2();
  afx_msg void OnCloseUpFunctionGpio3();
  afx_msg void OnCloseUpFunctionGpio4();
  afx_msg void OnCloseUpFunctionGpio1();
  afx_msg void OnCloseUpDriveModeGpio0();
  afx_msg void OnCloseUpDriveModeGpio1();
  afx_msg void OnCloseUpDriveModeGpio2();
  afx_msg void OnCloseUpDriveModeGpio4();
  afx_msg void OnCloseUpDriveModeGpio3();
  afx_msg void OnGpioSetAllToFactoryDefault();
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GPIO_H__E1DA3834_BD02_4E31_B2B0_801EF407C21B__INCLUDED_)
