//============================================================================
// 631_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
// Fans.h : header file
//
#if !defined(AFX_FANS_H__3A102757_3CC7_4B2C_BF82_C9295B5ED6EB__INCLUDED_)
#define AFX_FANS_H__3A102757_3CC7_4B2C_BF82_C9295B5ED6EB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// Fans dialog

class FansDlg : public CDialog
{
// Construction
public:
  FansDlg(CWnd* pParent = NULL);   // standard constructor
  BOOL Create();
  virtual BOOL FansDlg::OnInitDialog();
  void FansDlg::OnReceivedFanReport(COMMAND_PACKET *packet);
  void FansDlg::OnReceivedReportingStatus(COMMAND_PACKET *packet);
  void FansDlg::OnReceivedFanPower(COMMAND_PACKET *packet);
  int FansDlg::get_fan(COMMAND_PACKET *packet, char * output);

// Dialog Data
  //{{AFX_DATA(FansDlg)
  enum { IDD = IDD_FANS };
  //These arrays make the code compact :)
  //but they break the event handling in
  //the resource editor :(
  CButton m_fan_enable_tach[4];
  CButton m_smooth_fan[4];
  CComboBox m_fan_glitch[4];
  CComboBox m_fan_PPR[4];
  CEdit m_fan_power_percent[4];
  CEdit m_fan_rpm_display[4];
  CEdit m_fan_rpm_scale[4];
  CProgressCtrl m_fan_RPM_bar[4];
  CSliderCtrl m_fan_power_slider[4];
  //}}AFX_DATA

// Overrides
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(FansDlg)
  protected:
    virtual void PostNcDestroy();
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  //}}AFX_VIRTUAL

// Implementation
protected:
  CWnd* m_pParent;
  int m_nID;

  void FansDlg::OnTimer(UINT nIDEvent);
  void FansDlg::StartTimer(int iTimeInterval);
  void FansDlg::StopTimer(void);

  int last_fan_power[4];
  int fan_max_rpm[4];
  unsigned char last_glitch_settings[4];
  int time_since_new_data[4];

  //4-second moving filter
  int fan_smooth_history[4][8];

  int FansDlg::smooth_fan(int fan_index,
                          int new_rpm,
                          char * output);

  int FansDlg::Get_Fan_Scale(int fan_speed,
                             int old_max_rpm,
                             int fan_rpm_history[]);

  //2 reports per second, 10 second history
  #define FAN_HISTORY_LENGTH 20
  int fan_rpm_history[4][FAN_HISTORY_LENGTH];

  // Generated message map functions
  //{{AFX_MSG(FansDlg)
  afx_msg void OnCloseupFan1Glitch();
  afx_msg void OnCloseupFan2Glitch();
  afx_msg void OnCloseupFan3Glitch();
  afx_msg void OnCloseupFan4Glitch();
  afx_msg void OnEditChangeFanGlitch();
  afx_msg void OnFanRPMEnable();
  afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  afx_msg void OnClose();
  afx_msg void OnSmoothFan();
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_FANS_H__3A102757_3CC7_4B2C_BF82_C9295B5ED6EB__INCLUDED_)
